
#import logging.handlers
import traceback,re
import sys, argparse,os
import tarfile
import subprocess
import logging
from fastapi import FastAPI
from typing import Union
import logging
from pydantic import BaseModel
import uvicorn
import datetime
from fastapi.middleware.cors import CORSMiddleware
from fastapi import APIRouter, HTTPException
from jinja2 import Environment, FileSystemLoader
#from utils.restApi import RESTClient
import shutil
import json
import threading
import psycopg2
from utils import utils

logging.basicConfig(
    filename='/home/epm/pylog/fastApiApp.log',  # Specify the log file
    filemode='w',  # Append the log messages to the file
    format='%(asctime)s - %(name)s - %(levelname)s - %(message)s',
    level=logging.DEBUG  # Set the logging level to DEBUG
)
sysapp = logging.getLogger('deleteApp')

connection = psycopg2.connect(
    user="postgres",
    password="Wang_2023",
    host="192.168.124.87",
    port=15432,
    database="cmdb"
)
connection.autocommit = False
cursor = connection.cursor()

appDir='/data_disk/APP'
buildDir='/data_disk/UPLOAD/sys'

router = APIRouter()

class Item(BaseModel):
    json_str: str

def delete_app_handler(item_in):
    try:     
        sysapp.info(f"input analysys: {item_in}")
        json_str = item_in.json_str
        json_obj = json.loads(json_str)
        sysapp.debug(f"item: {json_obj}")     

        sysEnvid = json_obj['sysEnvid']  
        cust_name = json_obj['sysName']            

        sysapp.info('del app')
        app_dir=f"{appDir}/{cust_name}"
        cmd=f"pm2 delete {cust_name}_backend"
        subprocess.run(cmd, shell=True, capture_output=True, text=True)
        cmd=f"pm2 delete {cust_name}_etl_worker"
        subprocess.run(cmd, shell=True, capture_output=True, text=True)
        sysapp.info(f"removedirs {app_dir}")
        shutil.rmtree(app_dir, ignore_errors=True)        

        sysapp.info(f'update cmdb')
        sql = f"delete from epm_pm2_service where env_ywid='{sysEnvid}' and sys_name='{cust_name}'"
        sysapp.info(f"sql={sql}")
        cursor.execute(sql)
        connection.commit()
        sysapp.info("delete app success")
    except Exception as e:
        sysapp.error(e)
        return {"error": str(e)}

@router.delete("/delete_app")
def delete_app(item_in: Item):
    rsp={
            "status": "success",
        }
    thread1 = threading.Thread(target=delete_app_handler, args=(item_in,)) 
    thread1.start()
    return rsp
    
